; ---------------------------------------------------------------
;  Zeitverzgerungs-Prozess.
;  Die Verzgerung wird von dem Wert in AL gesteuert.

;  Wenn der Prozess endet, werden die CPU-Register auf den
;  Wert zurckgesetzt, der dort gespeichert war, bevor der 
;  Prozess aufgerufen wurde. Die Befehle Push, Pop, Pushf und Popf
;  werden benutzt, um das zu erreichen.  In unserem Beispiel wird 
;  ein Prozess dreimal wieder verwendet. Dieses Wiederverwenden ist
;  einer der Hauptvorteile von Prozessen.

;------ Das Hauptprogramm ----------------------------------------
Start:
	MOV	AL,8	; Ein kurzer Aufschub.
	CALL	30	; Rufe den Prozess bei Adresse [30] ab.

	MOV	AL,10	; Ein mittlerer Aufschub.
	CALL	30	; Rufe den Prozess bei Adresse [30] ab.

	MOV	AL,20	; Ein lngerer Aufschub.
	CALL	30	; Rufe den Prozess bei Adresse [30] ab.

	JMP	Start	; Springe zurck an den Anfang.

; ----- Verzgerungsprozess, gespeichert unter Adresse [30] -------------

	ORG	30	; Produziere den Maschinen-Code von Adresse [30]

	PUSH	AL	; Speichere AL im Stapelspeicher.
	PUSHF		; Speichere die CPU-Flags im Stapelspeicher.
Rep:
	DEC	AL	; Ziehe von AL 1 ab.
	JNZ	REP	; Springe zurck auf Rep, wenn AL nicht Null war.

	POPF		; Hole die CPU-Flags zurck vom Stapelspeicher.
	POP	AL	; Hole AL zurck vom Stapelspeicher.
	RET		; Komm aus dem Prozess heraus.

; ---------------------------------------------------------------
	ENDE
; ---------------------------------------------------------------

AUFGABE
=======	Mache das Ampel-Programm 02tlight.asm noch einmal.
	Verwende diesen Prozess, um realistische Pausen zu bekommen.  

AUFGABE
=======	Gib den Text noch einmal ein und zeige das Programm mit den 
	Prozessen an. Benutze einen Prozess, um den Text einzugeben, 
	und einen weiteren, um ihn sichtbar zu machen. 

; ---------------------------------------------------------------
