; --------------------------------------------------------------
; Ein Programm, um eine Reihe von Texten einzulesen 
; und sie in RAM abzuspeichern.
; Das Ende des Textes wird mit dem ASCII-Code zero/null bezeichnet.
; --------------------------------------------------------------

; DAS HAUPTPROGRAMM

	MOV	BL,70	; [70] ist die Adresse, unter der der Text
			; gespeichert wird. Die Prozedur benutzt diese Adresse. 
	CALL	10	; Die Procedur unter [10] liest den Text ein und
			; verschiebt ihn von der Adresse an 
			; nach BL.

			; BL sollte hier immer [70] enthalten.

	CALL	40	; Diese Prozedur tut bisher noch nichts.
			; Sie sollte den Text anzeigen.

	HALT		; Benutze hier nicht aus Versehen "END"!
			; Bei "HALT" hlt das Programm an, bei
			; "END" ist der Programmtext zu Ende.


; --------------------------------------------------------------

; PROZEDUR, UM DEN TEXT EINZULESEN

	ORG	10	; Der Code fngt bei Adresse [10] an.

	PUSH	AL	; Speichere AL im Stapelspeicher
	PUSH	BL	; Speichere BL im Stapelspeicher
	PUSHF		; Speichere die CPU-Flags (Zustandsanzeiger) 
			; in der Speicherzelle, die durch den Stapelspeicher 
			; SP angegeben wird.

Rep:
	IN	00	; Eingabe von Port 00 (Tastatur)
	CMP	AL,0D	; War der Tastendruck die Enter-Taste?
	JZ	Stop	; Wenn ja, springe auf Stop
	MOV	[BL],AL	; Kopiere den Tastendruck nach RAM auf die Position [BL]
	INC	BL	; BL weist auf die nchste Position hin.
	JMP	Rep	; Springe zurck, um den nchsten Buchstaben zu holen.

Stop:
	MOV	AL,0	; Hier ist die Marke fr NULL end 
	MOV	[BL],AL	; Schreibe NULL an diese Position.

	POPF		; Hole die Flags aus dem Stapelspeicher
	POP	BL	; Hole BL aus dem Stapelspeicher
	POP	AL	; Hole AL aus dem Stapelspeicher

	RET		; Verlasse die Prozedur.

; --------------------------------------------------------------
; EINE PROZEDUR, UM DEN TEXT AUF DEM SIMULIERTEN BILDSCHIRM ANZUZEIGEN

	ORG	40	; Der Code fngt bei Adresse [10] an.

			; **** DIESE LCKE MUSST DU SELBST FLLEN ****
			; Bis jetzt tut dieser Prozess nichts anderes
		        ; als zurckzukehren.

	RET
; --------------------------------------------------------------
	END		; Es ist richtig, END am Ende zu benutzen.
; --------------------------------------------------------------

AUFGABE
=======	Schreibe einen anderen Prozess, um den gespeicherten Text im
	simulierten VDU-Bildschirm anzuzeigen. Dazu gehrt auch, den
	Text von RAM auf Adressen, die mit C0 beginnen, zu kopieren.  
	Benutze ein Register, um auf den abgespeicherten Text hinzuweisen.  
	Benutze ein zweites Register, um auf den Bildschirm hinzuweisen.
	Benutze ein drittes, um den Text zu speichern, den du schreibst.

	HINWEIS:  Der Prozess, der den Text einliest, hat viel
		  hnlichkeit mit dem, den du neu schreibst. Betrachte
		  ihn genau. Vielleicht fllt dir etwas Gutes dazu ein.
; --------------------------------------------------------------
