; --------------------------------------------------------------
; BEISPIEL FR DEN GEBRAUCH VON HARDWARE-INTERRUPTS
; Dieses Programm dreht den Schrittmotor stndig und schaltet 
; die Ampel schrittweise nach jeder Hardware-Unterbrechung.

; Schalte die Box aus mit der Aufschrift "Zeige nur eine Ansicht",
; damit beide Anzeigen gleichzeitig erscheinen knnen.

; --------------------------------------------------------------
	Jmp	Start	; Springe ber die Tabelle mit den Unterbrechungsvektoren.
	DB	50	; Der Vektor in 02 weist auf Adresse 50 hin.
Start:
	STI		; Setze das I Flag. 
			; Ermgliche Unterbrechungen bei der Hardware.
	MOV	AL,11	;
Rep:
	OUT	05	; Schrittmotor
	ROR	AL	; Rotiere die Bits rechts in AL.
	JMP	Rep
	JMP	Start
; --------------------------------------------------------------
	ORG	50

	push	al	; Speichere AL gleich im Stapelspeicher.
	push	bl	; Speichere BL im Stapelspeicher.
	pushf		; Speichere die Flags im Stapelspeicher.

	Jmp	PastData
	DB	84	; Rot		Grn
	DB	c8	; Rot/Gelb	Gelb
	DB	30	; Grn		Rot
	DB	58	; Gelb		Rot/Gelb
	DB	57	; Fhrt durch die Tabelle
PastData:
	MOV	BL,[5B]	; BL weist jetzt auf die Datentabelle hin.
	MOV	AL,[BL]	; Die Daten aus der Tabelle gehen nach AL.
	OUT	01	; Schicke die Daten in AL an die Ampelanlage.
	CMP	AL,58	; Letzter Eintrag in der Tabelle
	JZ	Reset	; Wenn dies der letzte Eintrage ist, stelle den Zeiger zurck.
 	INC	BL	; BL weist auf den nchsten Tabelleneintrag hin.
	MOV	[5B],BL	; Speichere den Zeiger in RAM.
	JMP	Stop
Reset:
	MOV	BL,57	; Zeiger steht auf Datentabelle, er startet die Adresse.
	MOV	[5B],BL	; Speichere den Zeiger in RAM, Platz 54.
Stop:
	popf		; Stelle die Flags auf ihren ursprnglichen Wert ein.
	pop	bl	; Stelle BL auf seinen ursprnglichen Wert ein.
	pop	al	; Stelle AL auf seinen ursprnglichen Wert ein.

	IRET
; --------------------------------------------------------------
	ENDE
; --------------------------------------------------------------

AUFGABE
=======	1)	Schreibe ein Programm, das die Heizung und das Thermostat reguliert, 
		gleichzeitig immer wieder von 0 bis 9 zhlt 
		und das Ergebnis auf einer der sieben Anzeigen darstellt. 
	        Wenn du mehr Herausforderung brauchst, 
		zhle immer wieder von 0 bis 99 und benutze beide Anzeigen. 
		Verwende die simulierte Hardware-Unterbrechung,
		um die Heizung und das Thermostat zu steuern. 
	

	2)	Ein kniffliges Problem: Lse die Aufgabe "Turm von Hanoi", 
		whrend du die Schlange durch das Labyrinth lenkst. 
		Benutze die Buchstaben A,B,C etc. um die Disketten zu 
		bezeichnen. Verwende drei von den vier Reihen auf dem 
		Bildschirm, um die Sulen darzustellen.
