; Rechnen       Dieses Programm demonstriert die Arithmetikbefehle 
;		Es soll blockieren, wenn versehentlich durch Null geteilt wird.

;               Es gibt jeweils zwei Arten von Befehlen:
;   DIRECT	Hier wird die Rechnung nur mit Registern ausgefhrt.
;   IMMEDIATE	Hier wird die Rechnung mit einem Register und mit 
;		einem numerischen Wert ausgefhrt.

; Addition
	MOV	AL,2	; bertrage 2 Hex nach AL.
	MOV	BL,2	; bertrage 2 Hex nach BL.
	ADD	AL,BL	; AL wird AL + BL DIRECT
	ADD	AL,2	; AL wird AL + 2 IMMEDIATE
	INC	AL	; Vergrere oder addiere 1 zu AL.

; Addition, die einen Stellenberlauf verursacht
	MOV	AL,7F	; bertrage 7F Hex nach AL.
	MOV	BL,1	; bertrage 1 Hex nach BL.
	ADD	AL,BL	; AL wird AL + BL DIRECT
			; Die Antwort ist falsch wegen dem Stellenberlauf.

; Subtraktion
	MOV	AL,8	; bertrage 8 Hex nach AL.
	MOV	BL,5	; bertrage 5 Hex nach BL.
	SUB	AL,BL	; AL wird AL - BL DIRECT
	SUB	AL,2	; AL wird AL - 2 IMMEDIATE
	DEC	AL	; Verkleinere oder subtrahiere 1 von AL.

; Subtraktion, bei der man das Signal-Bit setzen muss
	MOV	AL,5	; bertrage 5 Hex nach AL.
	MOV	BL,8	; bertrage 5 Hex nach BL.
	SUB	AL,BL	; AL wird AL + BL DIRECT

; Multiplikation
	MOV	AL,2	; bertrage 2 Hex nach AL.
	MOV	BL,2	; bertrage 2 Hex nach BL.
	MUL	AL,BL	; AL wird AL * BL DIRECT
	MUL	AL,2	; AL wird AL * 2 IMMEDIATE

; Multiplikation, die einen berlauf verursacht
	MOV	AL,55	; bertrage 55 Hex nach AL.
	MOV	BL,2	; bertrage 2 Hex nach BL.
	MUL	AL,BL	; AL wird AL * BL DIRECT
			; Die Antwort ist falsch wegen dem berlauf.

; MOD  Das ist der Rest, der bei einer Division brigbleibt.
	MOV	AL,55	; bertrage 55 Hex nach AL.
	MOD	AL,10	; AL wird der Rest nach der 
			; Division durch 10. IMMEDIATE

	MOV	AL,76	; bertrage 76 Hex nach AL.
	MOV	DL,20	; bertrage 20 Hex nach AL.
	MOD	AL,DL	; AL wird der Rest nach der 
			; Division durch DL. DIRECT

; Division
	MOV	AL,10	; bertrage 10 Hex nach AL.
	MOV	BL,2	; bertrage 2 Hex nach BL.
	DIV	AL,BL	; AL wird AL div BL DIRECT
	DIV	AL,2	; AL wird AL div 2 IMMEDIATE

; Division durch Null: ERROR
	MOV	AL,10	; bertrage 10 Hex nach AL.
	MOV	BL,0	; bertrage 0 Hex nach BL.
	DIV	AL,BL	; AL wird AL div BL FAILS

	MOV	AL,10	; bertrage 10 Hex nach AL.
	DIV	AL,0	; AL wird AL div 0 FAILS

	END		; Programmende