; -------------------------------------------------
; Dieses Programm demonstriert den Vergleichsbefehl CMP,
; der normalerweise fr Sprnge genutzt wird. 
; -------------------------------------------------

; 	Vergleiche zwei Register
;       Halte die Schleife an, wenn die Register gleich sind.

Start:
	MOV	CL,0	; Initialisiere Zhler
	MOV	DL,10	; Initialisiere Testwert
rept1:
	INC	CL	; Zhle CL hoch
	CMP	CL,DL	; Vergleiche CL mit DL
			; Z-Flag (Zero) wird dabei gesetzt, wenn sie gleich sind
	JNZ	rept1	; Wiederhole, falls Z-Flag nicht gesetzt wurde

; -------------------------------------------------

; 	Vergleiche Registerinhalte
;	Halte an, wenn CL < DL

	MOV	CL,20	; Initialisiere Zhler
	MOV	DL,10	; Initialisiere Testwert
rept2:
	DEC	CL	; Zhle CL herunter
	CMP	CL,DL	; Vergleiche CL mit DL
			; S-Flag (Sign) wird dabei gesetzt, falls CL < DL
	JNS	rept2	; Wederhole, falls S-Flage nicht gesetzt wurde

; -------------------------------------------------

; 	Vergleiche direkt (Registerinhalt mit Zahl)
;	Halte an, wenn DL = 10

	MOV	DL,0	; Initialisiere Zhler
rept3:
	INC	DL	; Zhle DL hoch
	CMP	DL,10	; Vergleiche DL mit 10
			; Z-FLAG (Zero) wird dabei gesetzt, falls DL = 10
	JNZ	rept3	; Wiederhole, wenn Z-Flag nicht gesetzt wurde

; -------------------------------------------------

; 	Vergleiche direkt (Registerinhalt mit Zahl)
;	Halte an, wenn DL < 10

	MOV	DL,20	; Initialisiere Zhler
rept4:
	DEC	DL	; Zhle DL herunter
	CMP	DL,10	; Vergleiche DL mit 10
			; S-Flag (Sign) wird dabei gesetzt, falls DL < 10
	JNS	rept4	; Wiederhole, wenn S-Flag nicht gesetzt wurde

; -------------------------------------------------

; 	Vergleiche Indirekt (Registerinhalt mit Inhalt einer RAM-Adresse)
;	Halte an, wenn DL = RAM-Adresse [50]

	MOV	DL,0	; Initialisiere Zhler
	MOV	AL,10	; Testwert
	MOV	[50],AL	; Speichere Testwert nach RAM-Adresse [50]
rept5:
	INC	DL	; Zhle DL hoch
	CMP	DL,[50]	; Vergleiche DL mit RAM-Adresse [50]
			; Z-FLAG (Zero) wird dabei gesetzt, falls DL = 10
	JNZ	rept5	; Wiederhole, falls Z-Flag nicht gesetzt wurde

; -------------------------------------------------

; 	Vergleiche Indirekt (Registerinhalt mit Inhalt einer RAM-Adresse)
;	Halte an, wenn DL < RAM-Adresse  [50]

	MOV	DL,20	; Initialisiere Zhler
	MOV	AL,10	; Testwert
	MOV	[50],AL	; Speichere Testwert nach RAM-Adresse [50]
rept6:
	DEC	DL	; Zhle DL herunter
	CMP	DL,[50]	;  Vergleiche DL mit RAM-Adresse [50]
			; S-FLAG (Sign) wird dabei gesetzt, falls DL < 10
	JNS	rept6	; Wiederhole, falls S-Flag nicht gesetzt wurde


	JMP	Start

; -------------------------------------------------

	END

; -------------------------------------------------
