; Ein Demonstrationsprogramm, das viele Instruktionen und ebenso
; die meisten der Peripheralen bt, die im Simulator zur Verfgung stehen.
; CALL, RET, INT und IRET werden nicht verwendet, weil diese Befehle
; in der Shareware-Version nicht vorhanden sind.

; ----- DATENTABELLE---------------------------------------------

	CLO			; Schliee alle peripheren Fenster.

	JMP	HERE		; berspringe die Datensektion.

	DB	"HELLO WORLD!"	; Lade die Textzeile in RAM.
	DB	0		; Die Null wird definiert.

; ----- TEXTANZEIGE -------------------------------------------

HERE:
	MOV	CL,C0		; Adresse des Video ram base 
	MOV	BL,03		; Beginn der Textzeile

START:				; Textausgabe an VDU
	MOV	AL,[BL]		; Textanzeiger nach AL
	CMP	AL,0		; Schon zu Ende?
	JZ	END1		; Springe aus der Schleife hinaus.
	MOV	[CL],AL		; AL in den Video-Speicher
	INC	CL		; Nchste Videoposition
	INC	BL		; Nchster Buchstabe im Text
	JMP	START		; Noch nicht da
END1:

; ----- AMPELANLAGE -----------------------------------------
	MOV	BL,0C		; Lass die Lichter aufleuchten.
	MOV	AL,AA		; 1010 1010b
REP1:
	OUT	01		; Die Lichter sind in Port 1.
	NOT	AL		; 0101 0101b
	DEC	BL		; Zhle rckwrts.
	JNZ	REP1		; Springe bei Null aus der Schleife.

; ----- KLUDGE (?), WEIL DER MAXIMALE SPRUNG -128 IST ------------------------
	JMP	SKIPOVR		; Springe vorwrts ber "Springe zurck" hinweg.
MIDDLE:
	JMP	HERE		; Springe den Rest des Weges zurck.
SKIPOVR:

; ----- SIEBEN-SEGMENT-ANZEIGEN ---------------------------------
	MOV	BL,0C		; Lass die Sieben-Segment-Anzeigen aufleuchten.
REP2:
	MOV	AL,FF		; 1111 1111b
	OUT	02		; Die Lichter sind in Port 1.
	MOV	AL,FE		; 1111 1110b
	OUT	02		; LSB wird fr Multiplex gebraucht.

	MOV	AL,01		; 0000 0001b
	OUT	02		;
	MOV	AL,0		; 0000 0000b
	OUT	02		;

	DEC	BL		; Zhle rckwrts
	JNZ	REP2		; Springe bei Null aus der Schleife hinaus.

; ----- HEIZUNG UND THERMOSTAT ----------------------------------
	IN	03		; Eingabe vom Thermostat in Port 3
	CMP	AL,01		; Ist es zu warm?
	JZ	OFF		; Wenn nicht, springe auf OFF.
	MOV	AL,80		; Benutze MSB, um die Heizung anzustellen.
	OUT	03		; Schicke 10000000 nach Port 3.
	JMP	Skip2		; Springe ber den "Heizung aus"-Code hinweg.
OFF:	
	MOV	AL,0		; Stelle die Heizung aus mit 00000000.
	OUT	03		; Schicke 00000000 nach Port 3.
Skip2:
	MOV	BL,20		; Zeitaufschub
ON:	
	DEC	BL		; BL zhlt rckwrts fr den Zeitaufschub.
	JNZ	ON		; Springe bei Null aus der Schleife hinaus.

; ----- SCHLANGE IM LABYRINTH --------------------------------------
	MOV	AL,FF		; Richte das Labyrinth ein.
	OUT	04		; Die Schlange ist in Port 4.
	MOV	BL,0A		; Zhle rckwrts bis zum Startwert.
	MOV	AL,4F		; 4 bedeutet abwrts.  F bedeutet 15.
REP5:
	OUT	04		; Schicke die Daten an die Schlange.
	DEC	BL		; Zhle rckwrts.
	JNZ	REP5		; Springe bei Null aus der Schleife hinaus.

; ----- DREHE DEN SCHRITTMOTOR ---------------------------------
	MOV	BL,20		; Zhle rckwrts bis zum Startwert.
	MOV	AL,11		; 0001 0001b
REP6:
	OUT	05		; Der Schrittmotor ist auf Port 5.
	ROL	AL		; Drehe die Bits auf der linken Seite.
	DEC	BL		; Zhle rckwrts.
	JNZ	REP6		; Springe bei Null aus der Schleife hinaus.

; ----- RUME DEN VDU-BILDSCHIRM LEER -----------------------------------
	MOV	CL,C0		; Grundstzliche Adresse des Bildschirms
	MOV	BL,0C		; Leere eine Reihe auf dem Bildschirm.
	MOV	AL,20		; ASCII-Raum
REP7:
	MOV	[CL],AL		; Schicke die Daten an das Video-RAM.
	INC	CL		; Nchste RAM-Position
	DEC	BL		; Zhle rckwrts.
	JNZ	REP7		; Springe bei Null aus der Schleife hinaus.
	JMP	MIDDLE		; Springe zurck auf den Start.
; --------------------------------------------------------------	
	END
; --------------------------------------------------------------	
