; --------------------------------------------------------------

; Hier steht die Lsung fr eine bung fr einen fortgeschrittenen Schler.  

; Dieses Programm vergrert die Ziffern in der Sieben-Segment-Anzeige. 
; Die linke Ziffer zhlt stndig von 0 bis 9, und zwar in einer 
; Geschwindigkeit, die von dem CPU-Uhrentakt bestimmt wird.

; Die rechte Ziffer vergrert sich auch dauernd von 0 bis 9, und zwar
; in einer Geschwindigkeit, die von dem Ticken des simulierten Hardware-Unterbrechers
; bestimmt wird. Die zwei Ziffern sollten unabhngig voneinander funktionieren.  

; Diese bung verlangt den korrekten Gebrauch von push, pop, pushf 
; and popf, weil das Hauptprogramm jederzeit unterbrochen werden knnte. 
; Wenn der Unterbrechercode nicht von selbst hinter sich aufrumte, 
; wrde sehr bald ein Chaos entstehen.

; Die Sache fngt dann an schief zu gehen, wenn der Interrupt aufgerufen wird,
; bevor er Zeit hatte, seine Aufgabe zu beenden. Er wird dann zwar noch arbeiten, aber  
; letztendlich wird der Stapelspeicher das Programm berschreiben.

; --------------------------------------------------------------

	Jmp Start	; Springe ber die Datentabelle hinweg etc.

	DB	30	; Hardware-Zeitschaltuhr-Unterbrechungs-Vektor 
			; weist auf den Code bei [30] hin.

	DB	FA	; Die Datentabelle beginnt bei der Adresse [03].
	DB	0A
	DB	B6
	DB	9E
	DB	4E
	DB	DC
	DB	FC
	DB	8A
	DB	FE
	DB	CE	; Letzter Dateneintrag

	DB	03	; Diese RAM-Position zeigt auf die Datentabelle.
			; Der Unterbrecher-Code benutzt diese Adresse,
			; um seinen Fortgang durch die Datentabelle
			; verfolgen zu knnen.
; --------------------------------------------------------------
; DAS HAUPTPROGRAMM

Start:
	STI		; Aktiviere Hardware-Zeitschaltuhr-Unterbrechungen.
	Mov	BL,03	; BL enthlt die Datentabelle fr Start und Adresse.
Rep:
	MOV	AL,[BL]	; Verschiebe die Daten von der Tabelle nach AL.
	OUT	02	; Schicke die Daten zur Anzeige.
	CMP	AL,CE	; Test fr den Wert Tabellenende
	JZ	Start	; Wenn hier das Tabellenende ist, springe zurck zum Start.
	INC	BL	; Nchste Position in der Datentabelle
	JMP	Rep	; Springe zurck und bearbeite die nchste Ziffer.

; --------------------------------------------------------------
; UNTERBRECHUNGSBEARBEITER  Der folgende Code luft bei jedem Uhrenticken.

	ORG	30	; Der Code beginnt bei Adresse [30].

	PUSH	AL	; Speichere das AL-Register im Stapelspeicher.
	PUSH	BL	; Speichere das BL-Register im Stapelspeicher.
	PUSHF		; Speichere die CPU-Flags im Stapelspeicher.

	MOV	BL,[0D]	; RAM-Position 0D enthlt den 
			; Hinweis auf die Datentabelle.
	MOV	AL,[BL]	; Hole die Daten aus der Tabelle.
	OR	AL,1	; Setze LSB auf Eins. Das lst die andere 
			; Anzeige aus.
	OUT	02	; Schicke die Daten an die Anzeige.
	CMP	AL,CF	; Test fr den Endwert
	JZ	Reset	; Wenn das Tabellenende erreicht ist, richte den
			; Tabellenindex, der in RAM gespeichert ist, wieder ein.
	INC	BL	; Nchste Tabellenposition
	MOV	[0D],BL	; Speichere diese Tabellenposition in RAM.
	JMP	Done	; Springe ber den Code zum Wiedereinstellen des Zeigers.

Reset:
	MOV	BL,03	; 03 ist die Adresse vom Tabellenanfang.
	MOV	[0D],BL	; Speichere diesen Hinweis in RAM [0E].

Done:			; Alles beendet. Rume auf und gehe zurck.
	POPF		; Hole die CPU-Flags wieder aus dem Stapelspeicher.
	POP	BL	; Hole das BL-Register wieder aus dem Stapelspeicher.
	POP	AL	; Hole das AL-Register wieder aus dem Stapelspeicher.
	IRET		; Gehe zurck auf Interrupt.
; --------------------------------------------------------------
	END
	